#!/usr/bin/perl
# index.cgi
# Display a list of all Proscan Anti-Virus for Mailserver settings
require './proscan-lib.pl';

&ReadParse();

if( !(exists($in{'grp_id'})&& $in{'grp_id'} ne "") ){
	&redirect("mailscan_grp_list.cgi");
}

$gr_name=$in{'grp_id'};

$config=$config{'proscan_conf'};
&lock_file($config);

$proscan_conf = get_config();

&get_default_rule;
get_notify_rule("inf", "infected");
get_notify_rule("sus", "suspicious");
get_notify_rule("oth", "other");
get_notify_rule("flt", "filtered");
get_notify_rule("err", "error");
get_notify_rule("prot", "protected");


&put_config($proscan_conf);
&unlock_file($config);
&redirect("group_action_edit.cgi?grp_id=$in{'grp_id'}");

sub get_notify_rule{
	my($var_pref, $conf_pref) = @_;
	
	$section = "smtpscan.action.$conf_pref";
	
	$v1=get_bool(\%in, $var_pref."_qr");
	$v2=$in{$var_pref."_qpath"};
	$v3=get_bool(\%in, $var_pref."_admn");
	$v4=get_bool(\%in, $var_pref."_sndn");
	$v5=get_bool(\%in, $var_pref."_rpcn");
	$v6=$in{$var_pref."_attach"};
	$v7=$in{$var_pref."_ract"};
	$v8=$in{$var_pref."_cond"};
	
	# ǥեȤȰۤʤͤĤǤ⤢СȴФ
	if($d1 ne $v1 || $d2 ne $v2 || $d3 ne $v3 || $d4 ne $v4 || $d5 ne $v5 || $d6 ne $v6 || $d7 ne $v7 || $d8 ne $v8) {
	    $proscan_conf->{$gr_name}{$section}{'order'} = $order++ unless $proscan_conf->{$gr_name}{$section}{'order'};
	    
	    $proscan_conf->{$gr_name}{$section}{'content'}{'Quarantine'}=get_bool(\%in, $var_pref."_qr");
	    $proscan_conf->{$gr_name}{$section}{'content'}{'QuarantinePath'}=$in{$var_pref."_qpath"};
	    $proscan_conf->{$gr_name}{$section}{'content'}{'AdminNotify'}=get_bool(\%in, $var_pref."_admn");
	    $proscan_conf->{$gr_name}{$section}{'content'}{'SenderNotify'}=get_bool(\%in, $var_pref."_sndn");
	    $proscan_conf->{$gr_name}{$section}{'content'}{'RecipientNotify'}=get_bool(\%in, $var_pref."_rpcn");
	    $proscan_conf->{$gr_name}{$section}{'content'}{'RecipientAttachReport'}=$in{$var_pref."_attach"};
	    $proscan_conf->{$gr_name}{$section}{'content'}{'RecipientAction'}=$in{$var_pref."_ract"};
	    $proscan_conf->{$gr_name}{$section}{'content'}{'NotifyInternalOnly'}=$in{$var_pref."_cond"};
	} else {
	    delete $proscan_conf->{$gr_name}{$section}{'order'};
	    delete $proscan_conf->{$gr_name}{$section}{'content'};
	}
}

sub get_default_rule{
        $section = "smtpscan.action";

	$proscan_conf->{$gr_name}{$section}{'order'} = $order++ unless $proscan_conf->{$gr_name}{$section}{'order'};
	
	$d1=$proscan_conf->{$gr_name}{$section}{'content'}{'Quarantine'}=get_bool(\%in, "dflt_qr");
	$d2=$proscan_conf->{$gr_name}{$section}{'content'}{'QuarantinePath'}=$in{"dflt_qpath"};
	$d3=$proscan_conf->{$gr_name}{$section}{'content'}{'AdminNotify'}=get_bool(\%in, "dflt_admn");
	$d4=$proscan_conf->{$gr_name}{$section}{'content'}{'SenderNotify'}=get_bool(\%in, "dflt_sndn");
	$d5=$proscan_conf->{$gr_name}{$section}{'content'}{'RecipientNotify'}=get_bool(\%in, "dflt_rpcn");
	$d6=$proscan_conf->{$gr_name}{$section}{'content'}{'RecipientAttachReport'}=$in{"dflt_attach"};
	$d6="delete" if $d6 eq "";
	$d7=$proscan_conf->{$gr_name}{$section}{'content'}{'RecipientAction'}=$in{"dflt_ract"};
	$d7="reject" if $d7 eq "";
	$d8=$proscan_conf->{$gr_name}{$section}{'content'}{'NotifyInternalOnly'}=$in{"dflt_cond"};
	$d8="none" if $d8 eq "";
}
